## mlgtk 1.2.1.2000.01.10-5

=== Makefile ===
CC = gcc
CAMLC = ocamlc
CAMLO = ocamlopt

#CDEBUGFLAGS = -g -DDEBUG
CDEBUGFLAGS = -g -Wall -DGTKTHR -DEBUG
ZFLAGS = -g -thread
ZFLAGSOPT = 

# Be sure of what you are doing if you want to change this:
OCAMLDIR = $(shell $(CAMLC) -v | grep Standard | sed -e "s/^.*: //") 

# On the other hand you may want to adapt this:

DESTDIR =
INSTALL = install -m644
INSTDIR = $(DESTDIR)$(OCAMLDIR)


# path for Ocaml C header files
OC_CFLAGS = -I $(OCAMLDIR)
# OC_CFLAGS = -I/usr/lib/ocaml -I/usr/local/lib/ocaml

##############################################################
###  You should not need to customize anything below this  ###
##############################################################

.PHONY : all all_opt clean distclean install install_opt depend examples examples_opt

include detect_gtk

ifneq (,$(OK))

CFLAGS = $(CDEBUGFLAGS) $(OC_CFLAGS) $(GLIB_CFLAGS) \
         $(shell gtk-config --cflags) $(GTKDEFINES)
LDFLAGS = "$(GLIB_LIBS) $(shell gtk-config --libs) -lunix"

CMOFILES = glib.cmo gdk.cmo gtk.cmo gtkThr.cmo gtkObj.cmo gtkEasy.cmo gtkDrawing.cmo
CMXFILES = glib.cmx gdk.cmx gtk.cmx gtkThr.cmx gtkObj.cmx gtkEasy.cmx gtkDrawing.cmx
OFILES = mlgdk_stub.o mlglib_stub.o mlgtk_stub.o

all: print_message libs examples 
all_opt: libs_opt examples_opt

libs: gtk.cma libmlgtk.a 
libs_opt: gtk.cmxa libmlgtk.a 

examples: 
	make -C examples all

examples_opt: 
	make -C examples all_opt

print_message:
	@echo $(OK)

gtk.cma: $(CMOFILES)
	$(CAMLC) -a -o $@ $(CMOFILES)

gtk.cmxa: $(CMXFILES)
	$(CAMLO) -a -o $@ $(CMXFILES)

libmlgtk.a: $(OFILES)
	$(AR) -rc $@ $(OFILES)

gtkThr.cmx: gtkThr.ml
	$(CAMLO) -thread $(ZFLAGSOPT) -c $<
clean:
	-rm -f *.cm* *.o *.a 
	make -C examples clean

distclean: 
	-rm -f .depend *.cm* *.o *.a 
	make -C examples distclean

install: libs
	$(INSTALL) gtk.cma $(INSTDIR)
	$(INSTALL) libmlgtk.a $(INSTDIR)
	$(INSTALL) *.cmi $(INSTDIR)

install_opt: libs_opt
	$(INSTALL) gtk.cmxa gtk.a $(INSTDIR)

depend: 
	ocamldep *.ml* >.depend

.depend:
	ocamldep *.ml* >.depend

.ml.cmo:
	$(CAMLC) $(ZFLAGS) -c $<
.ml.cmx:
	$(CAMLO) $(ZFLAGSOPT) -c $<
.mli.cmi:
	$(CAMLC) $(ZFLAGS) -c $<

.SUFFIXES: .ml .cmo .cmx .mli .cmi

include .depend

endif

=== examples/Makefile ===
CC = gcc
CAMLC = ocamlc -g -thread
CAMLMKTOP = ocamlmktop -g -thread
CAMLO = ocamlopt -thread
CAMLINC = -I ..

ZOBJS = unix.cma threads.cma ../gtk.cma ../libmlgtk.a
ZOBJSOPT = unix.cmxa threads.cmxa ../gtk.cmxa ../libmlgtk.a

.PHONY : clean distclean depend all all_opt

# To define GTKDEFINES, GLIB_CFLAGS and GLIB_LIBS:
include ../detect_gtk

LDFLAGS = "${GLIB_LIBS} $(shell gtk-config --libs)	\
		-lunix -lthreads -lpthread"
LDFLAGSOPT = "${GLIB_LIBS} $(shell gtk-config --libs)	\
		-lunix -lthreadsnat -lpthread"
#LDFLAGS = "${GLIB_LIBS} $(shell gtk-config --libs) -lunix -lthreads"

TESTS = tut_1 tut_2 tut_3 tut_4 tut_cat tut_threads
XTESTS = tut_1_opt tut_2_opt tut_3_opt tut_4_opt tut_cat_opt

all: $(TESTS) 
all_opt: $(XTESTS) 

#tut_3:	../../gtk.cma ../../libmlgtk.a tut_3.cmo
#	$(CAMLMKTOP) -custom -o $@ -cclib $(LDFLAGS) unix.cma threads.cma $^

t%: t%.cmo
	$(CAMLC) -custom -o $@ -cclib $(LDFLAGS)	\
		$(ZOBJS) $+

t%_opt: t%.cmx
	$(CAMLO) -o $@ -cclib $(LDFLAGSOPT)		\
		$(ZOBJSOPT) $+

tut_cat: pty.cmo tut_cat.cmo
	$(CAMLC) -custom -o $@ -cclib $(LDFLAGS)	\
		$(ZOBJS) $+

tut_cat_opt: pty.cmx tut_cat.cmx
	$(CAMLO) -o $@ -cclib $(LDFLAGSOPT)		\
		$(ZOBJSOPT) $+

tut_threads:  tut_threads.cmo
	$(CAMLMKTOP) -custom -o $@ -cclib $(LDFLAGS) 	\
		$(ZOBJS) $^

clean:
	-rm -f *.cm* *.o $(TESTS) $(XTESTS)

distclean: clean
	-rm .depend

depend:
	ocamldep $(CAMLINC) *.ml* >.depend

.depend:
	ocamldep *.ml* >.depend

.ml.cmo:
	$(CAMLC) $(CAMLINC) $(ZFLAGS) -c $<
.ml.cmx:
	$(CAMLO) $(CAMLINC) $(ZFLAGSOPT) -c $<
.mli.cmi:
	$(CAMLC) $(CAMLINC) $(ZFLAGS) -c $<

.SUFFIXES: .ml .cmo .cmx .mli .cmi

include .depend

=== tools/c2caml/Makefile ===
#  C2caml : parses c headers and produces appropriate caml bindings for it
#  Copyright (C) 1999  Sven LUTHER
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# $Id: Makefile,v 1.1 1999/06/19 14:59:19 sven Exp $

CC =		gcc
CDEP =		gcc -MM
CAMLC =		ocamlc 
CAMLMKTOP =	ocamlmktop 
CAMLOPT =	ocamlopt
CAMLDEP =	ocamldep
CAMLLEX =	ocamllex
CAMLYACC =	ocamlyacc
AR =		ar
RANLIB =	ranlib

DIROBJS =	Objets
VPATH =	 	$(DIROBJS)

CAMLFLAGS =	-I $(DIROBJS)
CAMLOPTFLAGS =	-I $(DIROBJS)

CAMLLIB=/usr/lib/ocaml

SUBDIRS=''

EXE=c2caml_top c2caml

OBJS= 			\
	expr.cmo	\
	var.cmo		\
	par.cmo		\
	lex.cmo		\
	process.cmo	\

all: $(DIROBJS) core $(EXE)

c2caml_top: $(OBJS)
	ocamlmktop -custom $(CAMLFLAGS) -o $@ unix.cma $+ -cclib -lunix

c2caml: $(OBJS) main.cmo
	ocamlc -custom $(CAMLFLAGS) -o $@ unix.cma $+ -cclib -lunix

lex.ml: lex.mll par.cmo var.cmo
	$(CAMLLEX) lex.mll
	$(CAMLDEP) lex.ml >> .depend

par.ml par.mli: par.mly expr.cmo var.cmo
	$(CAMLYACC) par.mly
	$(CAMLDEP) par.mli par.ml >> .depend

par.cmo: par.cmi
main.cmo: lex.cmo par.cmo

clean:
	rm -rf $(DIROBJS) core .depend par.ml par.mli lex.ml $(EXE) 

.PHONY: co ci tag dep depend

co:	
	cvs update

ci:
	cvs ci

tag:
	cvs -R tag 

.SUFFIXES: .ml .mli .cmo .cmi .cmx .o

.mli.cmi:
	$(CAMLC) $(CAMLFLAGS) -c $<
	mv $@ $(DIROBJS)

.ml.cmo:
	$(CAMLC) $(CAMLFLAGS) -c $<
	if test -f $*.cmi; then mv $*.cmi $(DIROBJS); fi
	mv $@ $(DIROBJS)

.ml.cmx .ml.o:
	$(CAMLOPT) $(CAMLOPTFLAGS) -c $<
	mv $@ $(DIROBJS)
	if test -f $*.cmi; then mv $*.cmi $(DIROBJS); fi
	mv $*.o $(DIROBJS)

$(DIROBJS):
	mkdir $(DIROBJS)

core:
	mkdir core

depend .depend dep:
	$(CAMLDEP) $(INCLUDES) *.mli *.ml > .depend

include .depend

=== debian/changelog ===
mlgtk (1.2.1.2000.01.10-5) frozen unstable; urgency=low

  * write protected the doc/mlgtk/examples dir again since it breaks
    policy, too bad, it was nice to have.

 -- Sven LUTHER <luther@debian.org>  Thu, 24 Feb 2000 13:58:11 +0100

mlgtk (1.2.1.2000.01.10-4) frozen unstable; urgency=low

  * recompiled for frozen (potato).

 -- Sven LUTHER <luther@debian.org>  Fri,  4 Feb 2000 16:43:34 +0100

mlgtk (1.2.1.2000.01.10-3) unstable; urgency=low

  * Fixed build problem on m68k, where ocaml_opt is not supported yet.

 -- Sven LUTHER <luther@debian.org>  Wed, 26 Jan 2000 14:49:19 +0100

mlgtk (1.2.1.2000.01.10-2) unstable; urgency=low

  * Fixed the arc stuff in gtkDrawing.
  * Added an expose handler to the drawingarea creation function.

 -- Sven LUTHER <luther@debian.org>  Tue, 25 Jan 2000 15:25:18 +0100

mlgtk (1.2.1.2000.01.10-1) unstable; urgency=low

  * New upstream release.
  * Added propper thread support.

 -- Sven LUTHER <luther@debian.org>  Mon, 10 Jan 2000 20:11:07 +0100

mlgtk (1.2.0.19991108-3) unstable; urgency=low

  * Fixes Bug#54412 : Fixed compilation of example files.
  * Fixes Bug#54413 : Added documentation files that got lost somehow.

 -- Sven LUTHER <luther@debian.org>  Mon, 10 Jan 2000 19:30:25 +0100

mlgtk (1.2.0.19991108-2) unstable; urgency=low

  * Recompiled for ocaml 2.03 release.
  * ocaml is now free, so mlgtk can go into main.

 -- Sven LUTHER <luther@debian.org>  Mon, 22 Nov 1999 17:16:49 +0100

mlgtk (1.2.0.19991108-1) unstable; urgency=low

  * New upstream release.
  * fixes some get_color problem on non PSEUDOCOLOR visuals, just a quick fix
    for the lack of propper support for it in gtk+.

 -- Sven LUTHER <luther@debian.org>  Mon,  8 Nov 1999 16:38:53 +0100

mlgtk (1.2.0.19991102-1) unstable; urgency=low

  * New upstream release.

 -- Sven LUTHER <luther@debian.org>  Tue,  2 Nov 1999 19:26:56 +0100

mlgtk (1.2.0-1) unstable; urgency=low

  * New upstream release.

 -- Sven LUTHER <luther@debian.org>  Tue,  8 Jun 1999 15:49:27 +0200

mlgtk (1.0.990505-1) unstable; urgency=low

  * New upstream release.

 -- Sven LUTHER <luther@debian.org>  Wed,  5 May 1999 21:03:33 +0200

mlgtk (1.0.990406-2) unstable; urgency=low

  * fixed missing file for native compilation.

 -- Sven LUTHER <luther@debian.org>  Sat, 24 Apr 1999 11:31:18 +0100

mlgtk (1.0.990406-1) unstable; urgency=low

  * Stable upstream release, patch 990406.

 -- Sven LUTHER <luther@debian.org>  Mon, 19 Apr 1999 19:01:18 +0100

mlgtk (0.990304-1) unstable; urgency=low

  * New upstream release.

 -- Sven LUTHER <luther@debian.org>  Mon, 06 Mar 1999 16:17:18 +0100

mlgtk (0.990218-1) unstable; urgency=low

  * New upstream release.

 -- Sven LUTHER <luther@debian.org>  Mon, 18 Feb 1999 21:17:18 +0100

mlgtk (0.8.3-2) unstable; urgency=low

  * Some clean-up.
  * Added html documentation.

 -- Sven LUTHER <luther@debian.org>  Mon, 11 Feb 1999 17:36:18 +0100

mlgtk (0.8.3-1) unstable; urgency=low

  * Initial Release.

 -- Sven LUTHER <luther@debian.org>  Mon,  8 Feb 1999 19:36:18 +0100

Local variables:
mode: debian-changelog
add-log-mailing-address: "luther@debian.org"
End:

=== debian/control ===
Source: mlgtk
Section: devel
Priority: optional
Maintainer: Sven LUTHER <luther@debian.org>
Standards-Version: 2.4.0.0

Package: mlgtk
Architecture: any
Depends: ocaml (>= 2.03-1), libglib1.2, libgtk1.2
Description: Ocaml bindings for Gtk+
 Ocaml bindings for Gtk+

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir
	touch depend
	$(MAKE) depend

	# Add here commands to compile the package.
	$(MAKE) libs
	if [ -x /usr/bin/ocamlopt ]; then \
		$(MAKE) libs_opt; \
	fi

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	umask 022
	$(MAKE) install DESTDIR=`pwd`/debian/tmp
	if [ -x /usr/bin/ocamlopt ]; then \
		$(MAKE) install_opt DESTDIR=`pwd`/debian/tmp; \
	fi

	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples examples/tut_* examples/pty*
	install examples/Makefile.Debian	\
		$(PWD)/debian/tmp/usr/share/doc/mlgtk/examples/Makefile
	dh_installmenu
#	dh_installemacsen
#	dh_installinit
	dh_installcron
	dh_installmanpages
#	dh_undocumented
	dh_installchangelogs 
	dh_link
#	dh_strip
	dh_compress
	dh_fixperms
	dh_suidregister
	dh_installdeb
#	dh_shlibdeps
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## mlgtk 2.0.0

=== Makefile ===
--- 
+++ 
@@ -1,20 +1,22 @@
 CC = gcc
 CAMLC = ocamlc
 CAMLO = ocamlopt
+OCAMLMKLIB=ocamlmklib
 
-#CDEBUGFLAGS = -g -DDEBUG
-CDEBUGFLAGS = -g -Wall -DGTKTHR -DEBUG
+#CDEBUGFLAGS = -g -Wall -DGTKTHR -DDEBUG
+CDEBUGFLAGS = -g -Wall -DGTKTHR 
 ZFLAGS = -g -thread
 ZFLAGSOPT = 
 
 # Be sure of what you are doing if you want to change this:
-OCAMLDIR = $(shell $(CAMLC) -v | grep Standard | sed -e "s/^.*: //") 
+#OCAMLDIR = $(shell $(CAMLC) -v | grep Standard | sed -e "s/^.*: //") 
+OCAMLDIR = `$(CAMLC) -where`
 
 # On the other hand you may want to adapt this:
 
 DESTDIR =
 INSTALL = install -m644
-INSTDIR = $(DESTDIR)$(OCAMLDIR)
+INSTDIR = $(DESTDIR)$(OCAMLDIR)/mlgtk
 
 
 # path for Ocaml C header files
@@ -33,7 +35,7 @@
 
 CFLAGS = $(CDEBUGFLAGS) $(OC_CFLAGS) $(GLIB_CFLAGS) \
          $(shell gtk-config --cflags) $(GTKDEFINES)
-LDFLAGS = "$(GLIB_LIBS) $(shell gtk-config --libs) -lunix"
+LDFLAGS = $(shell gtk-config --libs)
 
 CMOFILES = glib.cmo gdk.cmo gtk.cmo gtkThr.cmo gtkObj.cmo gtkEasy.cmo gtkDrawing.cmo
 CMXFILES = glib.cmx gdk.cmx gtk.cmx gtkThr.cmx gtkObj.cmx gtkEasy.cmx gtkDrawing.cmx
@@ -54,20 +56,30 @@
 print_message:
 	@echo $(OK)
 
-gtk.cma: $(CMOFILES)
-	$(CAMLC) -a -o $@ $(CMOFILES)
+gtk.cma: $(CMOFILES) $(OFILES)
+	$(OCAMLMKLIB) -o gtk -oc mlgtk $(CMOFILES) $(OFILES) $(LDFLAGS)
 
 gtk.cmxa: $(CMXFILES)
-	$(CAMLO) -a -o $@ $(CMXFILES)
+	$(OCAMLMKLIB) -o gtk -oc mlgtk $(CMXFILES) $(OFILES) $(LDFLAGS)
 
-libmlgtk.a: $(OFILES)
-	$(AR) -rc $@ $(OFILES)
+#libmlgtk.a: $(OFILES)
+#	$(OCAMLMKLIB) -o gtk -oc mlgtk $(OFILES) $(LDFLAGS)
 
 gtkThr.cmx: gtkThr.ml
 	$(CAMLO) -thread $(ZFLAGSOPT) -c $<
+
+mli.docs:
+	if [ -x mli ]; then rm -rf mli; fi && mkdir mli
+	-for i in `ls --color=never *.ml`; do	\
+		ocamlc -i -c -o /dev/null $$i >mli/"$$i"i;	\
+	done
+	cp -f *.mli mli
+
 clean:
 	-rm -f *.cm* *.o *.a 
 	make -C examples clean
+	-rm -rf mli
+	-rm -f dllmlgtk.so
 
 distclean: 
 	-rm -f .depend *.cm* *.o *.a 
@@ -75,11 +87,12 @@
 
 install: libs
 	$(INSTALL) gtk.cma $(INSTDIR)
-	$(INSTALL) libmlgtk.a $(INSTDIR)
+	$(INSTALL) dllmlgtk.so $(INSTDIR)
 	$(INSTALL) *.cmi $(INSTDIR)
 
 install_opt: libs_opt
 	$(INSTALL) gtk.cmxa gtk.a $(INSTDIR)
+	$(INSTALL) libmlgtk.a $(INSTDIR)
 
 depend: 
 	ocamldep *.ml* >.depend

=== examples/Makefile ===
--- 
+++ 
@@ -4,19 +4,16 @@
 CAMLO = ocamlopt -thread
 CAMLINC = -I ..
 
-ZOBJS = unix.cma threads.cma ../gtk.cma ../libmlgtk.a
-ZOBJSOPT = unix.cmxa threads.cmxa ../gtk.cmxa ../libmlgtk.a
+ZOBJS = unix.cma threads.cma ../gtk.cma
+ZOBJSOPT = unix.cmxa threads.cmxa ../gtk.cmxa
 
 .PHONY : clean distclean depend all all_opt
 
 # To define GTKDEFINES, GLIB_CFLAGS and GLIB_LIBS:
 include ../detect_gtk
 
-LDFLAGS = "${GLIB_LIBS} $(shell gtk-config --libs)	\
-		-lunix -lthreads -lpthread"
-LDFLAGSOPT = "${GLIB_LIBS} $(shell gtk-config --libs)	\
-		-lunix -lthreadsnat -lpthread"
-#LDFLAGS = "${GLIB_LIBS} $(shell gtk-config --libs) -lunix -lthreads"
+LDFLAGS = "$(shell gtk-config --libs)"
+LDFLAGSOPT = ${GLIB_LIBS} $(shell gtk-config --libs)
 
 TESTS = tut_1 tut_2 tut_3 tut_4 tut_cat tut_threads
 XTESTS = tut_1_opt tut_2_opt tut_3_opt tut_4_opt tut_cat_opt
@@ -28,8 +25,7 @@
 #	$(CAMLMKTOP) -custom -o $@ -cclib $(LDFLAGS) unix.cma threads.cma $^
 
 t%: t%.cmo
-	$(CAMLC) -custom -o $@ -cclib $(LDFLAGS)	\
-		$(ZOBJS) $+
+	$(CAMLC) -o $@ -cclib $(LDFLAGS) $(CAMLINC) $(ZOBJS) $+
 
 t%_opt: t%.cmx
 	$(CAMLO) -o $@ -cclib $(LDFLAGSOPT)		\
